# Copyright (C) 2022 - 2024 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
    Granta.BomAnalyticsServices.V1

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: V1

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class CommonLegislationWithImpactedSubstances(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "impacted_substances": "list[CommonImpactedSubstance]",
        "legislation_id": "str",
    }

    attribute_map: dict[str, str] = {
        "impacted_substances": "ImpactedSubstances",
        "legislation_id": "LegislationId",
    }

    subtype_mapping: dict[str, str] = {
        "ImpactedSubstances": "CommonImpactedSubstance",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        impacted_substances: "Union[list[CommonImpactedSubstance], Unset_Type]" = Unset,
        legislation_id: "Union[str, Unset_Type]" = Unset,
    ) -> None:
        """CommonLegislationWithImpactedSubstances - a model defined in Swagger

        Parameters
        ----------
        impacted_substances: list[CommonImpactedSubstance], optional
        legislation_id: str, optional
        """
        self._legislation_id: Union[str, Unset_Type] = Unset
        self._impacted_substances: Union[list[CommonImpactedSubstance], Unset_Type] = Unset

        if legislation_id is not Unset:
            self.legislation_id = legislation_id
        if impacted_substances is not Unset:
            self.impacted_substances = impacted_substances

    @property
    def legislation_id(self) -> "Union[str, Unset_Type]":
        """Gets the legislation_id of this CommonLegislationWithImpactedSubstances.

        Returns
        -------
        Union[str, Unset_Type]
            The legislation_id of this CommonLegislationWithImpactedSubstances.
        """
        return self._legislation_id

    @legislation_id.setter
    def legislation_id(self, legislation_id: "Union[str, Unset_Type]") -> None:
        """Sets the legislation_id of this CommonLegislationWithImpactedSubstances.

        Parameters
        ----------
        legislation_id: Union[str, Unset_Type]
            The legislation_id of this CommonLegislationWithImpactedSubstances.
        """
        # Field is not nullable
        if legislation_id is None:
            raise ValueError("Invalid value for 'legislation_id', must not be 'None'")
        self._legislation_id = legislation_id

    @property
    def impacted_substances(self) -> "Union[list[CommonImpactedSubstance], Unset_Type]":
        """Gets the impacted_substances of this CommonLegislationWithImpactedSubstances.

        Returns
        -------
        Union[list[CommonImpactedSubstance], Unset_Type]
            The impacted_substances of this CommonLegislationWithImpactedSubstances.
        """
        return self._impacted_substances

    @impacted_substances.setter
    def impacted_substances(
        self, impacted_substances: "Union[list[CommonImpactedSubstance], Unset_Type]"
    ) -> None:
        """Sets the impacted_substances of this CommonLegislationWithImpactedSubstances.

        Parameters
        ----------
        impacted_substances: Union[list[CommonImpactedSubstance], Unset_Type]
            The impacted_substances of this CommonLegislationWithImpactedSubstances.
        """
        # Field is not nullable
        if impacted_substances is None:
            raise ValueError("Invalid value for 'impacted_substances', must not be 'None'")
        self._impacted_substances = impacted_substances

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, CommonLegislationWithImpactedSubstances):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
