# Copyright (C) 2022 - 2024 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
    Granta.BomAnalyticsServices.V1

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: V1

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class CommonSustainabilityProcessSummaryEntry(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "climate_change": "CommonValueWithUnit",
        "climate_change_percentage": "float",
        "embodied_energy": "CommonValueWithUnit",
        "embodied_energy_percentage": "float",
        "material_identity": "str",
        "material_record_reference": "CommonMaterialReference",
        "process_name": "str",
        "process_record_reference": "CommonProcessReference",
    }

    attribute_map: dict[str, str] = {
        "climate_change": "ClimateChange",
        "climate_change_percentage": "ClimateChangePercentage",
        "embodied_energy": "EmbodiedEnergy",
        "embodied_energy_percentage": "EmbodiedEnergyPercentage",
        "material_identity": "MaterialIdentity",
        "material_record_reference": "MaterialRecordReference",
        "process_name": "ProcessName",
        "process_record_reference": "ProcessRecordReference",
    }

    subtype_mapping: dict[str, str] = {
        "ProcessRecordReference": "CommonProcessReference",
        "MaterialRecordReference": "CommonMaterialReference",
        "EmbodiedEnergy": "CommonValueWithUnit",
        "ClimateChange": "CommonValueWithUnit",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        climate_change: "Union[CommonValueWithUnit, Unset_Type]" = Unset,
        climate_change_percentage: "Union[float, Unset_Type]" = Unset,
        embodied_energy: "Union[CommonValueWithUnit, Unset_Type]" = Unset,
        embodied_energy_percentage: "Union[float, Unset_Type]" = Unset,
        material_identity: "Union[str, Unset_Type]" = Unset,
        material_record_reference: "Union[CommonMaterialReference, Unset_Type]" = Unset,
        process_name: "Union[str, Unset_Type]" = Unset,
        process_record_reference: "Union[CommonProcessReference, Unset_Type]" = Unset,
    ) -> None:
        """CommonSustainabilityProcessSummaryEntry - a model defined in Swagger

        Parameters
        ----------
        climate_change: CommonValueWithUnit, optional
        climate_change_percentage: float, optional
        embodied_energy: CommonValueWithUnit, optional
        embodied_energy_percentage: float, optional
        material_identity: str, optional
        material_record_reference: CommonMaterialReference, optional
        process_name: str, optional
        process_record_reference: CommonProcessReference, optional
        """
        self._process_name: Union[str, Unset_Type] = Unset
        self._process_record_reference: Union[CommonProcessReference, Unset_Type] = Unset
        self._material_record_reference: Union[CommonMaterialReference, Unset_Type] = Unset
        self._material_identity: Union[str, Unset_Type] = Unset
        self._embodied_energy: Union[CommonValueWithUnit, Unset_Type] = Unset
        self._embodied_energy_percentage: Union[float, Unset_Type] = Unset
        self._climate_change: Union[CommonValueWithUnit, Unset_Type] = Unset
        self._climate_change_percentage: Union[float, Unset_Type] = Unset

        if process_name is not Unset:
            self.process_name = process_name
        if process_record_reference is not Unset:
            self.process_record_reference = process_record_reference
        if material_record_reference is not Unset:
            self.material_record_reference = material_record_reference
        if material_identity is not Unset:
            self.material_identity = material_identity
        if embodied_energy is not Unset:
            self.embodied_energy = embodied_energy
        if embodied_energy_percentage is not Unset:
            self.embodied_energy_percentage = embodied_energy_percentage
        if climate_change is not Unset:
            self.climate_change = climate_change
        if climate_change_percentage is not Unset:
            self.climate_change_percentage = climate_change_percentage

    @property
    def process_name(self) -> "Union[str, Unset_Type]":
        """Gets the process_name of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[str, Unset_Type]
            The process_name of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._process_name

    @process_name.setter
    def process_name(self, process_name: "Union[str, Unset_Type]") -> None:
        """Sets the process_name of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        process_name: Union[str, Unset_Type]
            The process_name of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if process_name is None:
            raise ValueError("Invalid value for 'process_name', must not be 'None'")
        self._process_name = process_name

    @property
    def process_record_reference(self) -> "Union[CommonProcessReference, Unset_Type]":
        """Gets the process_record_reference of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[CommonProcessReference, Unset_Type]
            The process_record_reference of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._process_record_reference

    @process_record_reference.setter
    def process_record_reference(
        self, process_record_reference: "Union[CommonProcessReference, Unset_Type]"
    ) -> None:
        """Sets the process_record_reference of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        process_record_reference: Union[CommonProcessReference, Unset_Type]
            The process_record_reference of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if process_record_reference is None:
            raise ValueError("Invalid value for 'process_record_reference', must not be 'None'")
        self._process_record_reference = process_record_reference

    @property
    def material_record_reference(self) -> "Union[CommonMaterialReference, Unset_Type]":
        """Gets the material_record_reference of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[CommonMaterialReference, Unset_Type]
            The material_record_reference of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._material_record_reference

    @material_record_reference.setter
    def material_record_reference(
        self, material_record_reference: "Union[CommonMaterialReference, Unset_Type]"
    ) -> None:
        """Sets the material_record_reference of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        material_record_reference: Union[CommonMaterialReference, Unset_Type]
            The material_record_reference of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if material_record_reference is None:
            raise ValueError("Invalid value for 'material_record_reference', must not be 'None'")
        self._material_record_reference = material_record_reference

    @property
    def material_identity(self) -> "Union[str, Unset_Type]":
        """Gets the material_identity of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[str, Unset_Type]
            The material_identity of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._material_identity

    @material_identity.setter
    def material_identity(self, material_identity: "Union[str, Unset_Type]") -> None:
        """Sets the material_identity of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        material_identity: Union[str, Unset_Type]
            The material_identity of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if material_identity is None:
            raise ValueError("Invalid value for 'material_identity', must not be 'None'")
        self._material_identity = material_identity

    @property
    def embodied_energy(self) -> "Union[CommonValueWithUnit, Unset_Type]":
        """Gets the embodied_energy of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[CommonValueWithUnit, Unset_Type]
            The embodied_energy of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._embodied_energy

    @embodied_energy.setter
    def embodied_energy(self, embodied_energy: "Union[CommonValueWithUnit, Unset_Type]") -> None:
        """Sets the embodied_energy of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        embodied_energy: Union[CommonValueWithUnit, Unset_Type]
            The embodied_energy of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if embodied_energy is None:
            raise ValueError("Invalid value for 'embodied_energy', must not be 'None'")
        self._embodied_energy = embodied_energy

    @property
    def embodied_energy_percentage(self) -> "Union[float, Unset_Type]":
        """Gets the embodied_energy_percentage of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[float, Unset_Type]
            The embodied_energy_percentage of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._embodied_energy_percentage

    @embodied_energy_percentage.setter
    def embodied_energy_percentage(
        self, embodied_energy_percentage: "Union[float, Unset_Type]"
    ) -> None:
        """Sets the embodied_energy_percentage of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        embodied_energy_percentage: Union[float, Unset_Type]
            The embodied_energy_percentage of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if embodied_energy_percentage is None:
            raise ValueError("Invalid value for 'embodied_energy_percentage', must not be 'None'")
        self._embodied_energy_percentage = embodied_energy_percentage

    @property
    def climate_change(self) -> "Union[CommonValueWithUnit, Unset_Type]":
        """Gets the climate_change of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[CommonValueWithUnit, Unset_Type]
            The climate_change of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._climate_change

    @climate_change.setter
    def climate_change(self, climate_change: "Union[CommonValueWithUnit, Unset_Type]") -> None:
        """Sets the climate_change of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        climate_change: Union[CommonValueWithUnit, Unset_Type]
            The climate_change of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if climate_change is None:
            raise ValueError("Invalid value for 'climate_change', must not be 'None'")
        self._climate_change = climate_change

    @property
    def climate_change_percentage(self) -> "Union[float, Unset_Type]":
        """Gets the climate_change_percentage of this CommonSustainabilityProcessSummaryEntry.

        Returns
        -------
        Union[float, Unset_Type]
            The climate_change_percentage of this CommonSustainabilityProcessSummaryEntry.
        """
        return self._climate_change_percentage

    @climate_change_percentage.setter
    def climate_change_percentage(
        self, climate_change_percentage: "Union[float, Unset_Type]"
    ) -> None:
        """Sets the climate_change_percentage of this CommonSustainabilityProcessSummaryEntry.

        Parameters
        ----------
        climate_change_percentage: Union[float, Unset_Type]
            The climate_change_percentage of this CommonSustainabilityProcessSummaryEntry.
        """
        # Field is not nullable
        if climate_change_percentage is None:
            raise ValueError("Invalid value for 'climate_change_percentage', must not be 'None'")
        self._climate_change_percentage = climate_change_percentage

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, CommonSustainabilityProcessSummaryEntry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
