# Copyright (C) 2022 - 2024 ANSYS, Inc. and/or its affiliates.
# SPDX-License-Identifier: MIT
#
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in all
# copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

"""
    Granta.BomAnalyticsServices.V1

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: V1

    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import re  # noqa: F401
from typing import TYPE_CHECKING, Any, BinaryIO, Optional, Union  # noqa: F401

from . import ModelBase, Unset, Unset_Type

if TYPE_CHECKING:
    from datetime import datetime
    import pathlib

    from . import *


class CommonSustainabilityTransportSummaryEntry(ModelBase):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes
    ----------
    swagger_types: dict[str, str]
        The key is attribute name and the value is attribute type.
    attribute_map: dict[str, str]
        The key is attribute name and the value is json key in definition.
    subtype_mapping: dict[str, str]
        The key is the unmangled property name and the value is the corresponding type.
    discriminator: Optional[str]
        Name of the property used as discriminator for subtypes.
    """
    swagger_types: dict[str, str] = {
        "climate_change": "CommonValueWithUnit",
        "climate_change_percentage": "float",
        "distance": "CommonValueWithUnit",
        "embodied_energy": "CommonValueWithUnit",
        "embodied_energy_percentage": "float",
        "record_reference": "CommonTransportReference",
        "stage_name": "str",
    }

    attribute_map: dict[str, str] = {
        "climate_change": "ClimateChange",
        "climate_change_percentage": "ClimateChangePercentage",
        "distance": "Distance",
        "embodied_energy": "EmbodiedEnergy",
        "embodied_energy_percentage": "EmbodiedEnergyPercentage",
        "record_reference": "RecordReference",
        "stage_name": "StageName",
    }

    subtype_mapping: dict[str, str] = {
        "RecordReference": "CommonTransportReference",
        "Distance": "CommonValueWithUnit",
        "EmbodiedEnergy": "CommonValueWithUnit",
        "ClimateChange": "CommonValueWithUnit",
    }

    discriminator: Optional[str] = None

    def __init__(
        self,
        *,
        climate_change: "Union[CommonValueWithUnit, Unset_Type]" = Unset,
        climate_change_percentage: "Union[float, Unset_Type]" = Unset,
        distance: "Union[CommonValueWithUnit, Unset_Type]" = Unset,
        embodied_energy: "Union[CommonValueWithUnit, Unset_Type]" = Unset,
        embodied_energy_percentage: "Union[float, Unset_Type]" = Unset,
        record_reference: "Union[CommonTransportReference, Unset_Type]" = Unset,
        stage_name: "Union[str, Unset_Type]" = Unset,
    ) -> None:
        """CommonSustainabilityTransportSummaryEntry - a model defined in Swagger

        Parameters
        ----------
        climate_change: CommonValueWithUnit, optional
        climate_change_percentage: float, optional
        distance: CommonValueWithUnit, optional
        embodied_energy: CommonValueWithUnit, optional
        embodied_energy_percentage: float, optional
        record_reference: CommonTransportReference, optional
        stage_name: str, optional
        """
        self._stage_name: Union[str, Unset_Type] = Unset
        self._record_reference: Union[CommonTransportReference, Unset_Type] = Unset
        self._distance: Union[CommonValueWithUnit, Unset_Type] = Unset
        self._embodied_energy: Union[CommonValueWithUnit, Unset_Type] = Unset
        self._embodied_energy_percentage: Union[float, Unset_Type] = Unset
        self._climate_change: Union[CommonValueWithUnit, Unset_Type] = Unset
        self._climate_change_percentage: Union[float, Unset_Type] = Unset

        if stage_name is not Unset:
            self.stage_name = stage_name
        if record_reference is not Unset:
            self.record_reference = record_reference
        if distance is not Unset:
            self.distance = distance
        if embodied_energy is not Unset:
            self.embodied_energy = embodied_energy
        if embodied_energy_percentage is not Unset:
            self.embodied_energy_percentage = embodied_energy_percentage
        if climate_change is not Unset:
            self.climate_change = climate_change
        if climate_change_percentage is not Unset:
            self.climate_change_percentage = climate_change_percentage

    @property
    def stage_name(self) -> "Union[str, Unset_Type]":
        """Gets the stage_name of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[str, Unset_Type]
            The stage_name of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._stage_name

    @stage_name.setter
    def stage_name(self, stage_name: "Union[str, Unset_Type]") -> None:
        """Sets the stage_name of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        stage_name: Union[str, Unset_Type]
            The stage_name of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if stage_name is None:
            raise ValueError("Invalid value for 'stage_name', must not be 'None'")
        self._stage_name = stage_name

    @property
    def record_reference(self) -> "Union[CommonTransportReference, Unset_Type]":
        """Gets the record_reference of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[CommonTransportReference, Unset_Type]
            The record_reference of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._record_reference

    @record_reference.setter
    def record_reference(
        self, record_reference: "Union[CommonTransportReference, Unset_Type]"
    ) -> None:
        """Sets the record_reference of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        record_reference: Union[CommonTransportReference, Unset_Type]
            The record_reference of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if record_reference is None:
            raise ValueError("Invalid value for 'record_reference', must not be 'None'")
        self._record_reference = record_reference

    @property
    def distance(self) -> "Union[CommonValueWithUnit, Unset_Type]":
        """Gets the distance of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[CommonValueWithUnit, Unset_Type]
            The distance of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._distance

    @distance.setter
    def distance(self, distance: "Union[CommonValueWithUnit, Unset_Type]") -> None:
        """Sets the distance of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        distance: Union[CommonValueWithUnit, Unset_Type]
            The distance of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if distance is None:
            raise ValueError("Invalid value for 'distance', must not be 'None'")
        self._distance = distance

    @property
    def embodied_energy(self) -> "Union[CommonValueWithUnit, Unset_Type]":
        """Gets the embodied_energy of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[CommonValueWithUnit, Unset_Type]
            The embodied_energy of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._embodied_energy

    @embodied_energy.setter
    def embodied_energy(self, embodied_energy: "Union[CommonValueWithUnit, Unset_Type]") -> None:
        """Sets the embodied_energy of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        embodied_energy: Union[CommonValueWithUnit, Unset_Type]
            The embodied_energy of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if embodied_energy is None:
            raise ValueError("Invalid value for 'embodied_energy', must not be 'None'")
        self._embodied_energy = embodied_energy

    @property
    def embodied_energy_percentage(self) -> "Union[float, Unset_Type]":
        """Gets the embodied_energy_percentage of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[float, Unset_Type]
            The embodied_energy_percentage of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._embodied_energy_percentage

    @embodied_energy_percentage.setter
    def embodied_energy_percentage(
        self, embodied_energy_percentage: "Union[float, Unset_Type]"
    ) -> None:
        """Sets the embodied_energy_percentage of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        embodied_energy_percentage: Union[float, Unset_Type]
            The embodied_energy_percentage of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if embodied_energy_percentage is None:
            raise ValueError("Invalid value for 'embodied_energy_percentage', must not be 'None'")
        self._embodied_energy_percentage = embodied_energy_percentage

    @property
    def climate_change(self) -> "Union[CommonValueWithUnit, Unset_Type]":
        """Gets the climate_change of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[CommonValueWithUnit, Unset_Type]
            The climate_change of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._climate_change

    @climate_change.setter
    def climate_change(self, climate_change: "Union[CommonValueWithUnit, Unset_Type]") -> None:
        """Sets the climate_change of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        climate_change: Union[CommonValueWithUnit, Unset_Type]
            The climate_change of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if climate_change is None:
            raise ValueError("Invalid value for 'climate_change', must not be 'None'")
        self._climate_change = climate_change

    @property
    def climate_change_percentage(self) -> "Union[float, Unset_Type]":
        """Gets the climate_change_percentage of this CommonSustainabilityTransportSummaryEntry.

        Returns
        -------
        Union[float, Unset_Type]
            The climate_change_percentage of this CommonSustainabilityTransportSummaryEntry.
        """
        return self._climate_change_percentage

    @climate_change_percentage.setter
    def climate_change_percentage(
        self, climate_change_percentage: "Union[float, Unset_Type]"
    ) -> None:
        """Sets the climate_change_percentage of this CommonSustainabilityTransportSummaryEntry.

        Parameters
        ----------
        climate_change_percentage: Union[float, Unset_Type]
            The climate_change_percentage of this CommonSustainabilityTransportSummaryEntry.
        """
        # Field is not nullable
        if climate_change_percentage is None:
            raise ValueError("Invalid value for 'climate_change_percentage', must not be 'None'")
        self._climate_change_percentage = climate_change_percentage

    @classmethod
    def get_real_child_model(cls, data: dict[str, str]) -> str:
        """Raises a NotImplementedError for a type without a discriminator defined.

        Parameters
        ----------
        data: ModelBase
            Object representing a subclass of this class

        Raises
        ------
        NotImplementedError
            This class has no discriminator, and hence no subclasses
        """
        raise NotImplementedError()

    def __repr__(self) -> str:
        """For 'print' and 'pprint'"""
        return self.to_str()

    def __eq__(self, other: Any) -> bool:
        """Returns true if both objects are equal"""
        if not isinstance(other, CommonSustainabilityTransportSummaryEntry):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other: Any) -> bool:
        """Returns true if both objects are not equal"""
        return not self == other
